; Z88 CamelForth
; camelifl.s (Interpreter words with support for files and blocks)

; User variables (initially zero)

    nohead INPUTFBUF,docon
	defw usr_fline

    nohead INPUTFLEN,docon
	defw $80

;X SAVE-INPUT	-- x1...xn n
;   >IN @  SOURCE			; always need >IN and SOURCE
;   BLK @ 0= IF				; ignore SOURCE-ID if BLK<>0
;   SOURCE-ID CASE
;      0 OF  0  ENDOF			; nothing extra for TIB
;     -1 OF  0  ENDOF			; or EVALUATE strings
;     2DUP >R SWAP FILE-POSITION THROW ROT 1+ 0 D- 2 R>	; get linestart
;   ENDCASE
;   ELSE  0  THEN			; nothing extra for block input
;   SOURCE-ID BLK @ 			; always need SOURCE-ID & BLK
;   ROT 5 + ;				; min 5 items
    head SAVEINPUT,10,"SAVE-INPUT",docolon,0,0
	defw TOIN,FETCH,SOURCE
	defw BLK,FETCH,ZEROEQUAL
	defw QBRANCH,svip6
	defw SOURCEID,TRUE,QBRANCH,svip1
	defw ZERO,OVER,EQUAL,QBRANCH,svip2,DROP
	defw ZERO
.svip1  defw BRANCH,svip7
.svip2  defw MINUSONE,OVER,EQUAL,QBRANCH,svip4,DROP
	defw ZERO
.svip3  defw BRANCH,svip7
.svip4  defw TWODUP,TOR,SWOP,FILEPOSITION,THROW,ROT,ONEPLUS
	defw ZERO,DMINUS,LIT,2,RFROM
	defw DROP
.svip5  defw BRANCH,svip7
.svip6  defw ZERO
.svip7  defw SOURCEID,BLK,FETCH
	defw ROT,LIT,5,PLUS,EXIT


;X RESTORE-INPUT	x1...xn n -- flag
;   ?DUP 0= IF  TRUE EXIT  THEN		; can't restore a null input
;   SWAP >R				; put BLK on return stack
;   R@ IF  DUP 5 =			; for block input, okay with 5 items
;   ELSE
;   OVER CASE
;     0 OF  DUP 5 =  ENDOF		; okay with 5 items for TIB
;    -1 OF  DUP 5 =  ENDOF		; or for EVALUATE string
;    >R DUP 7 =				; otherwise need 7 items
;    IF  DROP REPOSITION-FILE THROW	; reposition to start of line
;        INPUT-FBUF INPUT-FLEN R@ READ-LINE THROW	; re-read it
;	 DROP OVER =			; true if same line length
;	 R@ 5 ROT			; insert fileid & new item count
;    ELSE  FALSE  THEN		    	; not correct items for file
;    R>
;   ENDCASE
;   THEN  R> ROT ROT			; put BLK back
;   IF  DROP SOURCE-ID >R		; drop unneeded count, save old ID
;	BLK !  'SOURCE-ID !		; restore BLK, SOURCE-ID
;       BLK @ ?DUP
;       IF  ROT DROP BLOCK SWAP  THEN   ; for BLK<>0, get valid buffer
;       'SOURCE 2!  >IN !		; restore SOURCE and >IN
;	R@ 0= R@ -1 = OR 0=
;	IF  R@ CLOSE-FILE THROW  THEN	; close any current file
;	R> DROP FALSE
;   ELSE  FOR  DROP  STEP  TRUE	; discard bad parameters
;   THEN ;
    head RESTOREINPUT,13,"RESTORE-INPUT",docolon,0,0
	defw QDUP,ZEROEQUAL,QBRANCH,rstip1
	defw TRUE,EXIT
.rstip1 defw SWOP,TOR,RFETCH
	defw QBRANCH,rstipD
	defw DUP,LIT,5,EQUAL
	defw BRANCH,rstip8
.rstipD defw OVER,TRUE,QBRANCH,rstip2
	defw ZERO,OVER,EQUAL,QBRANCH,rstip3,DROP
	defw DUP,LIT,5,EQUAL
.rstip2 defw BRANCH,rstip8
.rstip3 defw MINUSONE,OVER,EQUAL,QBRANCH,rstip5,DROP
	defw DUP,LIT,5,EQUAL
.rstip4 defw BRANCH,rstip8
.rstip5 defw TOR,DUP,LIT,7,EQUAL
	defw QBRANCH,rstip6
	defw DROP,REPOSITIONFILE,THROW
	defw INPUTFBUF,INPUTFLEN,RFETCH,READLINE,THROW
	defw DROP,OVER,EQUAL
	defw RFETCH,LIT,5,ROT
	defw BRANCH,rstip7
.rstip6 defw FALSE
.rstip7 defw RFROM,DROP
.rstip8 defw RFROM,ROT,ROT
	defw QBRANCH,rstip9
	defw DROP,SOURCEID,TOR
	defw BLK,STORE,TICKSOURCEID,STORE
	defw BLK,FETCH,QDUP,QBRANCH,rstipE
	defw ROT,DROP,BLOCK,SWOP
.rstipE defw TICKSOURCE,TWOSTORE,TOIN,STORE
	defw RFETCH,ZEROEQUAL,RFETCH,MINUSONE,EQUAL,OR
	defw ZEROEQUAL,QBRANCH,rstipC
	defw RFETCH,CLOSEFILE,THROW
.rstipC defw RFROM,DROP,FALSE
	defw EXIT
.rstip9 defw TOR
.rstipA defw DROP,BRSTEP,rstipA
	defw TRUE
.rstipB defw EXIT


;X REFILL   -- f
;   BLK @ IF  1 BLK +!                          ; for block input, use next
;	      BLK @ BLOCK PAUSE 1024 TRUE
;   ELSE
;   SOURCE-ID CASE
;     0 OF  TIB DUP 80 ACCEPT SPACE TRUE  ENDOF
;    -1 OF  FALSE  ENDOF
;    >R
;    INPUT-FBUF INPUT-FLEN R@ READ-LINE	THROW PAUSE	; read a line
;    IF  INPUT-FBUF SWAP TRUE  THEN		; leave source-spec 
;    R>
;   ENDCASE
;   THEN
;   DUP IF  >R 'SOURCE 2!  0 >IN ! R>  THEN ;
    head REFILL,6,"REFILL",docode,0,0
    	push bc
    	ld bc,(usr_blk)
	ld a,b
	or c
	jr nz,rflBLK
	ld bc,(usr_srcid)
	ld a,b
	or c
	jr z,rflTIB
	ld a,b
	and c
	inc a
	jr z,rflSTR
.rflFIL	ld hl,usr_fline		; stack INPUT-FPOS INPUT-FLEN below FILEID
	push hl
	ld hl,$80
	push hl
	call docolon
	defw READLINE,THROW,PAUSE,refil1 ; leaves: u2 flag
.refil1	ld a,b
	or c
	pop hl			; HL=u2
	jp z,EXIT		; if end of file, just leave FALSE
	ld (usr_source),hl
	ld hl,usr_fline
	ld (usr_source+2),hl	; set source for line of file input
.refil3	ld bc,0
	ld (usr_in),bc		; reset >IN
	dec bc			; and leave TRUE
	jp EXIT
.rflSTR	inc bc			; if source is string, leave FALSE
	next
.rflBLK	inc bc			; go to next block number
	ld (usr_blk),bc
	call docolon
	defw BLOCK,PAUSE,refil2
.refil2	ld hl,1024
	ld (usr_source),hl
	ld (usr_source+2),bc	; set source for block
	jr refil3		; go to reset >IN and leave TRUE
.rflTIB	ld bc,usr_tib
	push bc
	ld bc,80
	call docolon
	defw ACCEPT,SPACE,refil5
.refil5	ld (usr_source),bc
	ld hl,usr_tib
	ld (usr_source+2),hl	; set source for terminal
	jr refil3		; go to reset >IN and leave TRUE


;Z INTERPRETM	i*x -- j*x
;   BEGIN  REFILL  WHILE  INTERPRET  REPEAT ;
    nohead INTERPRETM,docolon
.iprtm1 defw REFILL
	defw QBRANCH,iprtm2
	defw INTERPRET
	defw BRANCH,iprtm1
.iprtm2 defw EXIT


;X INCLUDE-FILE		i*x fileid -- j*x
;   >R ['] INTERPRETM INPUTFBUF INPUTFLEN R>
;   0 NEST-INPUT ;
    head INCLUDEFILE,12,"INCLUDE-FILE",docolon,0,0
	defw TOR,LIT,INTERPRETM,INPUTFBUF,INPUTFLEN,RFROM
	defw ZERO,NESTINPUT,EXIT


;X INCLUDED		i*x caddr u -- j*x
;   R/O OPEN-FILE THROW
;   INCLUDE-FILE ;
    head INCLUDED,8,"INCLUDED",docolon,0,0
	defw RSLASHO,OPENFILE,THROW
	defw INCLUDEFILE,EXIT


;C (    --                     skip input until )
;   SOURCE-ID
;   IF  BEGIN  [CHAR] ) PARSE 2DROP
;	       SOURCE NIP >IN @ =
;	       DUP IF  DROP SOURCE + 1- C@ [CHAR] ) <>
;		       DUP IF  DROP REFILL  THEN 
;		   THEN
;       0= UNTIL
;   ELSE  [CHAR] ) PARSE 2DROP
;   THEN ; IMMEDIATE
    head PAREN,1,"(",docolon,1,0
        defw SOURCEID,QBRANCH,paren3
.paren1 defw LIT,$29,PARSE,TWODROP
	defw SOURCE,NIP,TOIN,FETCH,EQUAL
	defw DUP
	defw QBRANCH,paren2
	defw DROP,SOURCE,PLUS,ONEMINUS,CFETCH,LIT,$29,NOTEQUAL
	defw DUP
	defw QBRANCH,paren2
	defw DROP,REFILL
.paren2 defw ZEROEQUAL,QBRANCH,paren1
	defw EXIT
.paren3 defw LIT,$29,PARSE,TWODROP
.paren4 defw EXIT


;C S"       --         get in-line string
;   STATE C@
;   IF  POSTPONE (S") (")
;   ELSE  [CHAR] " PARSE
;	  usr_stringscr 2DUP C!
;         CHAR+ SWAP 2DUP 2>R
;         CMOVE 2R>
;   THEN ; IMMEDIATE
    head SQUOTE,2,"S"&$22,docolon,1,0
	defw STATE,CFETCH
	defw QBRANCH,squot1
	defw LIT,XSQUOTE,COMMAXT
	defw BRQUOTE
	defw EXIT
.squot1 defw LIT,$22,PARSE
	defw LIT,usr_stringscr,TWODUP,CSTORE
	defw CHARPLUS,SWOP,TWODUP,TWOTOR
	defw CMOVE,TWORFROM
.squot2 defw EXIT


;X \		-- comments to end of line
;   BLK @
;   IF  >IN @ 64 / 1+ 16 MIN 64 *
;   ELSE  SOURCE NIP
;   THEN  >IN ! ; IMMEDIATE
    head BACKSLASH,1,"\",docolon,1,0
	defw BLK,FETCH
	defw QBRANCH,bslsh1
	defw TOIN,FETCH,LIT,64,SLASH,ONEPLUS
	defw LIT,16,MIN,LIT,64,STAR
	defw BRANCH,bslsh2
.bslsh1 defw SOURCE,NIP
.bslsh2 defw TOIN,STORE,EXIT


; BLOCK words =================================

; User variables (initially zero)
;  'BUFFER		; address of block buffer data structure or zero
;  BLOCK-IDS		; IDs of files containing blocks (4 cells or zero)
;  #BUFS		; number of buffers 1..4

; The block buffer data structure is as follows:
;  +0 (4) Buffer MRU list
;  +4 (8) Block number for each buffer (or 0) with bit 15=update flag
; +12 (x) 1024 bytes per block buffer

    nohead TICKBUFFER,docon
	defw usr_tickbuffer

    nohead BLOCKID,docon
	defw usr_blockids

    nohead NUMBUFS,docon
	defw usr_numbufs

; 1-4 block buffers are allocated in RAM with BLKS. EMPTY-BUFFERS is used by
; BLKS and COLD to initialise the structure.
; If any attempt to access blocks is made before this, exception -35
; is THROWn. Interpretation words using blocks may THROW implementation-
; defined file exceptions.

;X EMPTY-BUFFERS
;   'BUFFER @ ?DUP
;   IF  0 SWAP  4 FOR  2DUP C! SWAP 1+ SWAP 1+  STEP  NIP
;       8 ERASE
;   THEN ;
    head EMPTYBUFFERS,13,"EMPTY-BUFFERS",docode,0,0
	ld hl,(usr_tickbuffer)
	ld a,h
	or l
	jp z,next_code			; do nothing if no structure
	push bc
	ld bc,$0400			; B=4, C=0
.blkin1	ld (hl),c			; set MRU list to 0,1,2,3
	inc hl
	inc c
	djnz blkin1
	ld bc,$0800			; B=8, C=0
.blkin2	ld (hl),c			; erase list of block numbers
	inc hl
	djnz blkin2
	pop bc
	next

; BLKS ( n -- )
;   'BUFFER @ OVER 1- 3 U> OR
;   IF  -4092 THROW  THEN	; exception if blocks already allocated
;   DUP #BUFS C!
;   CURDS @ RAM HERE 'BUFFER !		; store address of structure in RAM
;   SWAP 10 LSHIFT 12 + ALLOT		; allocate region
;   CURDS ! EMPTY-BUFFERS ;		; reset dataspace & initialise struct
    head BLKS,4,"BLKS",docolon,0,0
	defw TICKBUFFER,FETCH,OVER,ONEMINUS,LIT,3,UGREATER,OR
	defw QBRANCH,blks1
	defw LIT,-4092,THROW
.blks1	defw DUP,NUMBUFS,CSTORE
	defw CURDS,FETCH,RAM,HERE,TICKBUFFER,STORE
	defw SWOP,LIT,10,LSHIFT,LIT,12,PLUS,ALLOT
	defw CURDS,STORE,EMPTYBUFFERS,EXIT

; Four block mappings are available, with n as follows:
;  n=0	blocks     1...4096
;  n=1  blocks  4097...8192
;  n=2  blocks  8193..12288
;  n=3  blocks 12289..16384

;Z MAP		caddr u n --		Map range of blocks to a file
;   DUP UNMAP
;   >R  R/W OPEN-FILE THROW  BLOCKID R> 2* + ! ;
    head MAP,3,"MAP",docolon,0,0
	defw DUP,UNMAP
	defw TOR,RSLASHW,OPENFILE,THROW
	defw BLOCKID,RFROM,TWOSTAR,PLUS,STORE,EXIT

;Z UNMAP	n --			Unmap file from range of blocks
;   DUP 3 U> IF  -35 THROW  THEN	exception -35 if invalid block range
;   FLUSH
;   2* BLOCKID + DUP @
;   ?DUP IF  CLOSE-FILE THROW  THEN
;   0 SWAP ! ;
    head UNMAP,5,"UNMAP",docolon,0,0
	defw DUP,LIT,3,UGREATER,QBRANCH,unmap2
	defw LIT,-35,THROW
.unmap2 defw FLUSH
	defw TWOSTAR,BLOCKID,PLUS,DUP,FETCH
	defw QDUP,QBRANCH,unmap1
	defw CLOSEFILE,THROW
.unmap1	defw ZERO,SWOP,STORE,EXIT

;Z BLOCK-SEEK	u -- fileid		Seek to a block
;   BLOCKS? 1- 4 NSPLIT
;   2* BLOCKID + @ >R
;   1024 UM* R@ REPOSITION-FILE THROW
;   R> ;
    nohead BLOCKSEEK,docolon
	defw BLOCKSQ
	defw ONEMINUS,LIT,4,NSPLIT
	defw TWOSTAR,BLOCKID,PLUS,FETCH,TOR
	defw LIT,1024,UMSTAR,RFETCH,REPOSITIONFILE,THROW
	defw RFROM
	defw EXIT

;Z SAVEBUF	n --			Save block in buffer n if necessary
    nohead SAVEBUF,docode
	ld hl,(usr_tickbuffer)
	ld a,c
	add hl,bc
	add hl,bc
	ld c,5
	add hl,bc			; HL points to high byte of block num
	bit 7,(hl)
	jr z,svbuf2			; do nothing if not updated
	res 7,(hl)
	ld b,(hl)
	dec hl
	ld c,(hl)			; BC=block number
	exx
	ld hl,(usr_tickbuffer)
	ld bc,12
	add hl,bc			; HL points to buffer 0
	ld bc,1024
	and a
	jr z,svbuf1
.svbflp	add hl,bc
	dec a
	jr nz,svbflp
.svbuf1	push hl				; stack address of buffer to save
	push bc				; stack 1024
	exx
	call docolon
	defw BLOCKSEEK,WRITEFILE,THROW,EXIT
.svbuf2	pop bc				; new TOS
	next

;Z BLOCKS?				THROW an exception if no blocks
;   'BUFFER @ 0=
;   IF  -35 THROW  THEN ;
    nohead BLOCKSQ,docode
	ld hl,(usr_tickbuffer)
	ld a,h
	or l
	jp nz,next_code			; okay if 'BUFFER<>0
.thro35	ld bc,-35
	jp THROW			; else -35 THROW

;Z FINDBUF	u -- caddr flag		Find buffer for block: TRUE if loaded
;					Updates MRU list. Does BLOCKS? itself
    nohead FINDBUF,docode
	push bc
	exx				; use alternate set
	pop bc
	ld hl,(usr_tickbuffer)
	ld a,h
	or l
	jr z,thro35			; error if no blocks
	dec bc
	ld a,b
	inc bc
	and $c0
	jr nz,thro35			; or if block number >16384
	inc hl
	inc hl
	inc hl
	inc hl				; HL=address of block list
	ld a,4				; A=4-current buf#
.fbuf1	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	res 7,d
	ex de,hl
	and a
	sbc hl,bc
	ex de,hl
	jr z,fbuf2			; move on if found block in a buffer
	dec a
	jr nz,fbuf1			; back to search others
	ld a,(usr_numbufs)
	dec a				; A=offset of LRU buffer
	push bc				; save block number
	ld c,a
	ld b,0
	ld hl,(usr_tickbuffer)
	push hl
	add hl,bc
	ld c,(hl)			; BC=LRU buffer number
	pop hl
	inc hl
	inc hl
	inc hl
	inc hl
	add hl,bc
	add hl,bc			; HL=address to store block #
	push hl				; save it
	push bc
	call setmru			; set it as MRU buffer, get addr in HL
	pop bc
	push hl				; stack caddr
	ld hl,0
	push hl				; stack FALSE
	push bc
	exx				; back to normal set
	pop bc				; TOS=LRU buffer number again
	call docolon
	defw SAVEBUF,TWOSWAP,STORE,EXIT	; save buffer, set block #, exit
.fbuf2	ld e,a
	ld a,4
	sub e
	ld c,a				; C=buffer number
	call setmru			; set it as MRU buffer, get addr in HL
	push hl				; stack caddr
	exx				; back to normal set
	ld bc,-1			; TOS=TRUE, found in buffer
	next

; SetMRU subroutine
; On entry, C=buffer number (0..3)
; On exit, HL=address of buffer

.setmru	ld de,(usr_tickbuffer)		; DE=address of MRU list
	ld hl,12-1024
	add hl,de			; HL=address of buffer 0 - 1024
	ex de,hl
	ld b,c
.setmr2	ld a,(hl)
	ld (hl),b			; move entries down list
	inc hl
	ld b,a
	cp c
	jr nz,setmr2			; until position of ours filled
	ex de,hl
	ld de,1024
	inc c
.setmr3	add hl,de
	dec c
	jr nz,setmr3			; generate buffer address
	ret

;X UPDATE
;   BLOCKS?
;   'BUFFER @ DUP C@ 2* + 4 +
;   DUP @ 32768 OR SWAP ! ;  
    head UPDATE,6,"UPDATE",docode,0,0
	ld hl,(usr_tickbuffer)
	ld a,h
	or l
	jp z,thro35			; do the -35 THROW if no 'BUFFER
	push bc
	ld a,(hl)			; A=MRU buffer number
	add a,a
	ld c,a
	ld b,0
	add hl,bc
	ld c,5
	add hl,bc			; HL points to high byte of block number
	pop bc
	set 7,(hl)			; set update flag
	next

;X SAVE-BUFFERS
;   BLOCKS? 
;   #BUFS C@ 0 DO  I SAVEBUF  LOOP ;
    head SAVEBUFFERS,12,"SAVE-BUFFERS",docolon,0,0
	defw BLOCKSQ
	defw NUMBUFS,CFETCH,ZERO,XDO
.saveb1	defw II,SAVEBUF,XLOOP,saveb1
	defw EXIT

;X FLUSH
;   SAVE-BUFFERS EMPTY-BUFFERS ;
    head FLUSH,5,"FLUSH",docolon,0,0
	defw SAVEBUFFERS,EMPTYBUFFERS,EXIT

;X BUFFER	u -- addr
;   FINDBUF DROP ;
    head BUFFER,6,"BUFFER",docolon,0,0
	defw FINDBUF,DROP
	defw EXIT

;X BLOCK	u -- addr
;   DUP FINDBUF
;   IF  NIP
;   ELSE  TUCK 1024 ROT BLOCK-SEEK READ-FILE THROW DROP
;   THEN ;
    head BLOCK,5,"BLOCK",docolon,0,0
	defw DUP,FINDBUF
	defw QBRANCH,block1
	defw NIP,EXIT
.block1	defw TUCK,LIT,1024,ROT
	defw BLOCKSEEK,READFILE,THROW,DROP
	defw EXIT

;X LOAD		i*x u -- j*x
;   >R
;   ['] INTERPRET R@ BLOCK 1024 0 R>
;   NEST-INPUT ; 
    head LOAD,4,"LOAD",docolon,0,0
        defw TOR
	defw LIT,INTERPRET,RFETCH
	defw BLOCK,LIT,1024,ZERO,RFROM
	defw NESTINPUT,EXIT

;X THRU		i*x u1 u2 -- j*x
;   1+ SWAP DO  I LOAD  LOOP ;
    head THRU,4,"THRU",docolon,0,0
	defw ONEPLUS,SWOP,XDO
.thru1  defw II,LOAD,XLOOP,thru1
	defw EXIT

